﻿using Infragistics.Win;
using Infragistics.Win.Misc;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace UltraTilePanelScrollBar
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            for (int i = 0; i < 10; i++)
            {
                ultraTilePanel1.Tiles.Add(new Infragistics.Win.Misc.UltraTile("Tile " + i.ToString())
                {
                    Control = new TextBox() { Text = "This is Tile " + i.ToString() }
                });
            }
            
            ultraTilePanel1.DrawFilter = new TilePanelDrawFilter();
            ultraTilePanel1.MouseEnterElement += UltraTilePanel1_MouseEnterElement;
            ultraTilePanel1.MouseLeaveElement += UltraTilePanel1_MouseLeaveElement;            
        }

        private void UltraTilePanel1_MouseLeaveElement(object sender, UIElementEventArgs e)
        {
            if(e.Element is UltraTilePanelControlUIElement)
            {
                System.Diagnostics.Debug.WriteLine("Mouse Leave Element: " + e.Element);                
                (ultraTilePanel1.DrawFilter as TilePanelDrawFilter).IsMouseOutsideTilePanel = true;
                e.Element.DirtyChildElements(true);                                
            }
        }

        private void UltraTilePanel1_MouseEnterElement(object sender, UIElementEventArgs e)
        {            
            if (e.Element is UltraTilePanelControlUIElement)
            {
                System.Diagnostics.Debug.WriteLine("Mouse Enter Element " + e.Element);                
                (ultraTilePanel1.DrawFilter as TilePanelDrawFilter).IsMouseOutsideTilePanel = false;
                e.Element.DirtyChildElements(true);                                
            }
        }
    }

    public class TilePanelDrawFilter : IUIElementDrawFilter
    {
        public bool IsMouseOutsideTilePanel { get; set; }

        public bool DrawElement(DrawPhase drawPhase, ref UIElementDrawParams drawParams)
        {
            if(drawPhase == DrawPhase.BeforeDrawElement)
            {
                return IsMouseOutsideTilePanel;
            }
            else
            {
                return false;
            }
        }

        public DrawPhase GetPhasesToFilter(ref UIElementDrawParams drawParams)
        {
            if (drawParams.Element.GetType().Name == "VeritcalScrollBarUIElement")
            {
                return DrawPhase.BeforeDrawElement;
            }
            else
            {
                return DrawPhase.AfterDrawElement;
            }        
        }
    }
}
